/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

/* [] END OF FILE */

#include "functions.h"
#include <project.h>
#include <math.h>
#include <stdio.h>


volatile unsigned long millis = 0;
volatile char timeout_active = 0x00;
int8 cmdreply;
int8 cmdreply1; 
int8 answer;
char aux_str[100];
char serverdata[100];

char pin[] = "8845"; 
char apn[] = "internet"; 
char user_name[]="*";
char IP_address[] = "52.89.0.193"; 
char port[] = "65534";
char password[]="*";
char ibike_data[40]="1 1 R <EOM>\r\n";
char iPark_data[40] = "1 1 RB <EOM>\r\n";
char S_Serverdata[40] = "1 1 CC <EOM>";
char keypay[40] = "1 RS <EOM>";
char response[100] = {0};
char resp[100] = {0};
char resp1[100] = {0};
uint8 i = 0; 
uint8 ans = 0; 
uint8 j     = 0; 
uint8 Rx    = 0; 
uint8 t = 0;  


void StartTimeout()
{
	millis = 0;
	timeout_active = 0x01;
}

void StopTimeout()
{
	timeout_active = 0x00;
}


int8 sendATcommand(char const * ATcommand, char const * expected_answer){
    uint8 x = 0;
	int8 answer = -1;
    char response[100] = {0};
    GPRS_1_PutString(ATcommand);

    //StartTimeout();
    
do {

        if(GPRS_1_GetRxBufferSize() != 0){  
			
            response[x++] = GPRS_1_GetChar();		
                if (strstr(response, expected_answer) != NULL)    
            {				
             
                answer = 1;
				break;
            }
			//- Fail faster than timeout
			if (strstr(response, "ERROR") != NULL)    
            {				
                
                answer = 0;
				break;
            }
        }
    
   
}
 while(answer == -1);  
// StopTimeout();

CyDelay(200);
	
    return answer;

}

int8 sendATcommand2(const char* ATcommand, const char* expected_answer1, const char* expected_answer2)
{
   
    uint8 x = 0;
	int8 answer = 0;
    char response[100] = {0};
    GPRS_1_PutString(ATcommand);
   // UART_1_PutString("HER");
    do {
 
        if(GPRS_1_GetRxBufferSize() != 0){  
			
            response[x++] = GPRS_1_GetChar();		
                if (strstr(response, expected_answer1) != NULL)    
            {				
             
                answer = 1;
				break;
            }
			//- Fail faster than timeout
			else if (strstr(response, expected_answer2) != NULL)    
            {				
                
                answer = 2;
				break;
            }
        }
  
   
}
 while(answer == 0);  
// StopTimeout();
 //GPRS_1_PutString(response);
CyDelay(200);
	
    return answer;

}
    

void initservercommunication()
{
    if(sendATcommand2("AT+CIPMUX=0 \r", "OK", "ERROR") == 1)
   
    
    //UART_1_PutString("1"); 
   // Waits for status IP INITIAL
{
    while(sendATcommand("AT+CIPSTATUS \r","INITIAL") == 0)    // Venter på Initial
     CyDelay(200); 
     UART_2_PutString("2"); 
     sprintf(aux_str, "AT+CSTT=\"%s\",\"%s\",\"%s\"\r", apn, user_name, password);
     if(sendATcommand2(aux_str, "OK",  "ERROR") == 1)
      {
       UART_2_PutString("3"); 
       // Waits for status IP START
        while(sendATcommand("AT+CIPSTATUS \r", "START")  == 0 );
        CyDelay(200); 
        UART_2_PutString("4"); 
         if (sendATcommand2("AT+CIICR \r", "OK", "ERROR") == 1)
          {
           UART_2_PutString("5"); 
           // Waits for status IP GPRSACT
           while(sendATcommand("AT+CIPSTATUS \r", "GPRSACT")  == 0 );
           // CyDelay(200)
           UART_2_PutString("6"); 
                // Gets Local IP Address
            if(sendATcommand2("AT+CIFSR \r", ".", "ERROR") == 1)
             {
             UART_2_PutString("7"); 
             while(sendATcommand("AT+CIPSTATUS \r", "IP STATUS")  == 0 );
             //CyDelay(200);     
                 }
            } 
       }
   UART_2_PutString("8");
   
}
}

void udlejning()
{
ans= 0; 
// Opens a TCP socket
  UART_2_PutString("8"); 
   sprintf(aux_str, "AT+CIPSTART=\"TCP\",\"%s\",\"%s\"\r", IP_address, port);
    if(sendATcommand2(aux_str, "CONNECT OK", "CONNECT FAIL") == 1)    
     {
       UART_2_PutString("9");
        //  Sends some data to the TCP socket
        sprintf(aux_str,"AT+CIPSEND=%d \r", strlen(ibike_data));
         if(sendATcommand2(aux_str, ">", "ERROR") == 1)    
          {
            UART_2_PutString("10");
             sendATcommand2(ibike_data, "SEND OK", "ERROR");
              do {
               //UART_1_PutString("11");
               if(GPRS_1_GetRxBufferSize() != 0){   // Returns the number of received bytes remaining in the RX buffer
                resp[i++] = GPRS_1_GetChar();       
                UART_2_PutString("12");  
                 if (strstr(resp, "<EOM>") != NULL)    
                  {				
                  UART_2_PutString("13");
                
                  sprintf(aux_str,"AT+CIPSEND=%d \r", strlen(S_Serverdata));
                  if (sendATcommand2(aux_str, ">", "ERROR") == 1)    //CIPSEND
                  { 
                    
                   UART_2_PutString("14");
                   sendATcommand2(S_Serverdata, "SEND OK", "ERROR");
                // open lock sendes 1OL<EOM>
                Pin_1_Write(1);                     // set pin high ready to send; 
                CyDelay(100);     
                UART_1_PutString("1OL<EOM>");
                UART_2_PutString("1OL<EOM>");
                CyDelay(5);                         // delay
                Pin_1_Write(0);
                
                  //here 1BR <EOM> (BIKE REALSED)´
                CyDelay(100); 
                sprintf(aux_str,"AT+CIPSEND=%d \r", strlen(keypay));
                  if (sendATcommand2(aux_str, ">", "ERROR") == 1)    //CIPSEND
                  { 
                   UART_2_PutString("15");
                   sendATcommand2(keypay, "SEND OK", "ERROR");  
                  ans = 1; 
                  UART_2_PutString(resp);                       }
                   
                
            }
                            
                  //ans = 1; 
                // UART_1_PutString(resp);                       }
            }
} 
        
    }  while(ans == 0); 
  }
    UART_1_PutString("15");
    // GPRS_1_PutString(resp);
    sendATcommand2("AT+CIPCLOSE \r", "CLOSE OK", "ERROR");
    memset (resp ,0 ,100);
    i = 0; 
    // UART_1_PutString(resp);     
    //GPRS_1_PutString(resp);
    ans = 0; 
       }  } 
    
   

void returning()
{
 
    ans= 0; 
// Opens a TCP socket
 UART_2_PutString("1");

   sprintf(aux_str, "AT+CIPSTART=\"TCP\",\"%s\",\"%s\"\r", IP_address, port);
    if(sendATcommand2(aux_str, "CONNECT OK", "CONNECT FAIL") == 1)    
     {
       UART_2_PutString("2");
        //  Sends some data to the TCP socket
        sprintf(aux_str,"AT+CIPSEND=%d \r", strlen(iPark_data));
         if(sendATcommand2(aux_str, ">", "ERROR") == 1)    
          {
            //UART_1_PutString("");
             sendATcommand2(iPark_data, "SEND OK", "ERROR");
            UART_2_PutString("3");
              do {
               //UART_1_PutString("11");
               if(GPRS_1_GetRxBufferSize() != 0 ) //  lOOK HERE. 
            {  
                resp1[t++] = GPRS_1_GetChar();
                
               // UART_1_PutString("DATA");  
                
                 if (strstr(resp1, "RC<EOM>") != NULL)    
                  {				
                    //   UART_1_PutString("D"); 
                    sendATcommand2("AT+CIPCLOSE \r", "CLOSE OK", "ERROR");
                    
                {  
                  
                 
                  UART_2_PutString(resp1); 
                  udlejning();
                  ans = 1; 
                }
                }
        
    } 
            } while(ans == 0); 
            
} 
  memset (resp1 ,0 ,100);
  t = 0; 
    }
    

else  if(sendATcommand2(aux_str, "CONNECT OK", "CONNECT FAIL") == 2) 
{
    
    returning(); 
    }
}


void handl(uint8 Rx) {
    
   // delay 
 
    switch( Rx ) {
    
        case 'A' : 
           // UART_2_PutString("Smuk pige");
            j = 0; 
            Pin_1_Write(1);                     // set pin high ready to send; 
            CyDelay(100);     
            UART_2_PutString("10<EOM>"); // delay 
            UART_1_PutString("10<EOM>"); 
            CyDelay(5);                         // delay
            Pin_1_Write(0);
           
                                       // set pin low, ready to receive again. 
            break; 
            
        case 'B' :                                                                                                        
            
            j = 0;
            //CyDelay(2000); 
           UART_2_PutString("Battery error"); 
           //CyDelay(100); 
            returning(); 
             
          
            break; 
            
        case 'C' : 
           
            j = 0; 
            Pin_2_Write(1);                      // Set Led hight 
            UART_2_PutString("Correct Return"); 
     //       returning(); 
  break; 
       default:
		UART_2_PutString("WRONG ID");;
		break;
    } 
}
 


void plccom( ) {
    
char  Rxbuffer[100];   

//GPRS_1_ClearRxBuffer();

if(UART_1_GetRxBufferSize()  !=  0 ) {

        Rxbuffer[j++] = UART_1_GetChar();
      //  UART_1_PutString(Rxbuffer);
       
    }

    Rx = ' ';
    
    if (strstr(Rxbuffer, "10<EOM>") != NULL)  Rx = 'A';
   
    if (strstr(Rxbuffer, "1BE<EOM>") != NULL)  Rx =  'B'; 

    if (strstr(Rxbuffer, "1OK<EOM>") != NULL) Rx = 'C';

    if (strstr(Rxbuffer, "1IB<EOM>") != NULL) Rx = 'D';  
    
    if ( Rx != ' ' ){
        memset (Rxbuffer ,0 ,100);
        handl( Rx );
        Rx = ' '; 
    }
  //UART_2_PutString(Rxbuffer);  
}
